package cn.com.qmth.stmms.ms.marking.assembler;

import cn.com.qmth.stmms.ms.marking.dto.MarkQuestionStatDTO;
import cn.com.qmth.stmms.ms.marking.dto.QuestionStatDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import cn.com.qmth.stmms.ms.core.repository.LevelRepo;
import cn.com.qmth.stmms.ms.core.repository.PaperRepo;

/**
 * Created by zhengmin on 2016/10/14.
 */
@Component
public class QuestionStatAssembler {

    @Autowired
    private LevelRepo levelRepo;

    @Autowired
    private PaperRepo paperRepo;

    public QuestionStatDTO toDTO(Object[] qStats){
        return this.assemble(qStats);
    }

    public QuestionStatDTO toDTOWithMarkers(Object[] qStats){
        QuestionStatDTO qpDTO = this.assemble(qStats);
        if(qpDTO != null){

        }
        return qpDTO;
    }

    private QuestionStatDTO assemble(Object[] qStats){
        QuestionStatDTO qpDTO = null;
        if(qStats != null){
            qpDTO = new QuestionStatDTO();
            qpDTO.setId(qStats[0]);
            qpDTO.setName(qStats[1]);
            qpDTO.setLeftCount(qStats[2]);
            qpDTO.setTotalCount(qStats[3]);
            qpDTO.setAreaCode(qStats[4]);
        }
        return qpDTO;
    }

    public QuestionStatDTO toProgressDTO(Object[] qStats){
        QuestionStatDTO qpDTO = null;
        if(qStats != null){
            qpDTO = new QuestionStatDTO();
            qpDTO.setAreaCode(qStats[0]);
            qpDTO.setAreaName(qStats[1]);
            qpDTO.setName(qStats[2]);
            qpDTO.setLeftCount(qStats[3]);
            qpDTO.setTotalCount(qStats[4]);
        }
        return qpDTO;
    }


    public MarkQuestionStatDTO toMarkProgressDTO(Object[] qStats){
        MarkQuestionStatDTO qpDTO = null;
        if(qStats != null){
            qpDTO = new MarkQuestionStatDTO();
            qpDTO.setId(qStats[0]);
            qpDTO.setMarkerName(qStats[1]);
            qpDTO.setName(qStats[2]);
            qpDTO.setLeftCount(qStats[3]);
            qpDTO.setTotalCount(qStats[4]);
            qpDTO.setRejectedCount(qStats[5]);
            qpDTO.setChangeStage(qStats[6]);
            qpDTO.setChangeStageScore(qStats[7]);
            qpDTO.setAreaCode(qStats[8]);
        }
        return qpDTO;
    }
}
